<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStepAlt, SlpBreadcrumb } from '../../components/common/index.vue';

import { CONTENT_TYPES } from '../../common/content-types';
import BrowseCaseStudies from '../../components/customers/browse-case-studies.vue';
import { getClient } from '~/plugins/contentful.js';
import { AvailableLanguagesMixin, FooterEditLinkMixin } from '~/mixins';
import {
  convertToCaseSensitiveLocale,
  getAvailableLanguagesFromTags,
} from '~/common/util';

export default Vue.extend({
  components: {
    NextStepAlt,
    SlpBreadcrumb,
    BrowseCaseStudies,
  },
  nuxtI18n: false,
  mixins: [FooterEditLinkMixin, AvailableLanguagesMixin],
  async middleware(context) {
    if (process.client) {
      return;
    }

    const locale = convertToCaseSensitiveLocale(context.i18n.locale);
    const { items } = await getClient().getEntries({
      content_type: CONTENT_TYPES.PAGE,
      'fields.slug': 'customers/all',
      locale,
    });

    const [page] = items;

    context.$pageData = page;

    context.$availableLanguages = getAvailableLanguagesFromTags(
      page.metadata.tags,
    );
  },
  async asyncData({ $pageData, i18n, $content, $availableLanguages }) {
    try {
      const locale = convertToCaseSensitiveLocale(i18n.locale);
      const data = $pageData.fields;
      const spaceId = $pageData.sys.space.sys.id;
      const entryId = $pageData.sys.id;
      const metadata = {
        title: data.seoMetadata[0].fields.ogTitle,
        ogTitle: data.seoMetadata[0].fields.ogTitle,
        description: data.seoMetadata[0].fields.ogDescription,
        ogDescription: data.seoMetadata[0].fields.ogDescription,
      };

      const caseStudiesResponse = await getClient().getEntries({
        content_type: 'caseStudy',
        'fields.filterCompanySize[exists]': true,
        'fields.filterIndustry[exists]': true,
        'fields.filterRegion[exists]': true,
        order: '-fields.date',
        locale,
      });

      const baseData = await $content(
        `shared/${i18n.locale}/customers/all-base-template`,
      ).fetch();

      const caseStudiesList = caseStudiesResponse.items;

      return {
        data,
        baseData,
        caseStudiesList,
        metadata,
        spaceId,
        entryId,
        availableLanguages: $availableLanguages,
      };
    } catch (error) {
      throw new Error(error);
    }
  },
  data() {
    return {
      UrlQuery: {},
    };
  },
  head() {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
      this.availableLanguages,
    );
  },
  watch: {
    UrlQuery() {
      this.UrlQuery = this.$route.query;
    },
  },
  created() {
    this.UrlQuery = this.$route.query;
  },
});
</script>

<template>
  <div>
    <SlpContainer class="slp-my-lg-32 slp-mt-8 slp-mb-24">
      <SlpRow>
        <SlpBreadcrumb :crumbs="baseData.crumbs" />
      </SlpRow>
      <SlpRow
        class="slp-mt-0 slp-mt-lg-64"
        :class="baseData.header ? '' : 'slp-mb-8'"
      >
        <SlpTypography class="slp-mt-24" variant="heading2-bold">
          {{ baseData.header }}
        </SlpTypography>
      </SlpRow>
    </SlpContainer>
    <client-only>
      <BrowseCaseStudies
        :case-studies-list="caseStudiesList"
        :data="baseData.browse_case_studies"
        :url-query="UrlQuery"
      />
    </client-only>

    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
.header {
  &__button {
    padding-left: 0;
  }
}
</style>
